/*
bhclock.h
Copyright (C) 2003  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#ifndef _CRAPCLOCK_H_
#define _CRAPCLOCK_H_

#include <gtkmm/main.h>
#include <gtkmm/window.h>
#include <gtkmm/drawingarea.h>
#include <gdkmm/color.h>
#include <gdkmm/gc.h>
#include <sigc++/sigc++.h>

namespace bhpos{

/**
 * \ingroup mflib
 * @{	
 */

namespace widget{
/**
 * \defgroup clock Clock
 * @{
 *
 * \ingroup bhwidget
 * @{	
 */
/*! BhClock 
   brief A class to handle a clock.
*/
class BhClock : public Gtk::DrawingArea
{
private:
   bool   bColon;
	int	 xsMonth[12], xeMonth[12], ydMonth;
	int	 xsDayOfMonth[31];
	int	 xeDayOfMonth[31];
	int	 xeDayOfMonth2[31];
	//int	 yDayOfMonth[31];
	int	 xdDayOfMonth[31];
	int	 xdDayOfMonth2[31];
	int	 ydDayOfMonth;
	int	 xsDayOfWeek[7], xeDayOfWeek[7], ydDayOfWeek;
	int	 xsDigits[12], xeDigits[12], xdDigits[11], ydDigits;
	int	 xsAMPM[2], yAMPM, xdAMPM[2], ydAMPM;
	tm		 *Time;
	int	 i, n, wid, extrady, extradx;
   int 	 Year, Month, DayOfWeek, DayOfMonth, OldDayOfMonth;
   int	 Hours, Mins, Secs, OldMins, digit, xoff, D[10], xsize;
   long	 CurrentLocalTime;
   time_t CurrentTime;
   int	 Flag, dFlag;
   bool   Show24HourTime;
   double UT, TU, TU2, TU3, T0, gmst, jd(), hour24();
   
protected:
   Glib::RefPtr<Gdk::Window> window;
   Glib::RefPtr<Gdk::GC>     gc;
   Glib::RefPtr<Gdk::Pixbuf> final;
   Glib::RefPtr<Gdk::Pixbuf> facia;
   Glib::RefPtr<Gdk::Pixbuf> date;
   Glib::RefPtr<Gdk::Pixbuf> day;
   Glib::RefPtr<Gdk::Pixbuf> month;
   Glib::RefPtr<Gdk::Pixbuf> timen;

	//Gdk::Color	transparent_color;	
	void DrawTime();
   void DrawDayMonth();
	void Draw();
	
	sigc::connection conn;
	gint	con_tag;
	virtual void on_realize();
	virtual bool on_expose_event(GdkEventExpose *e);

public:
	BhClock();
	~BhClock();
	gint Load(const std::string& facianame, const std::string& datename, const std::string& dayname, const std::string& monthname, const std::string& timename);
	bool Update();
	double JulianDay(int ny, int nm, int nd, double UT);
	double Hour24(double hour);
};

/* @} 
	@} */

}
/* @} */
}

#endif // _crapclock_h_
