/*
bhcustbox.h
Copyright (C) 2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/

#ifndef _BHCUSTBOX_H
#include <gtkmm/dialog.h>
#include <gtkmm/button.h>
#include <gtkmm/image.h>
#include <gtkmm/label.h>
#include <gtkmm/entry.h>
#include <gtkmm/table.h>

namespace bhpos{

/**
 * @ingroup mflib
 * @{	
 */
   
namespace widget{

/**
 * @defgroup bhcustbox Customer Box
 * @{
 *
 * @ingroup bhwidget
 * @{	
 */
#define _BHCUSTBOX_H

class bhcustbox : public Gtk::Dialog
{
protected:
   class Gtk::Label  *l_msg;
   class Gtk::Label  *l_title;
   class Gtk::Label  *l_fname;
   class Gtk::Label  *l_lname;
   class Gtk::Label  *l_phone;
   class Gtk::Label  *l_pcode;
   class Gtk::Image  *icon;
   class Gtk::Entry  *ctitle;
   class Gtk::Entry  *fname;
   class Gtk::Entry  *lname;
   class Gtk::Entry  *phone;
   class Gtk::Entry  *pcode;
	class Gtk::Button *yes;
	class Gtk::Button *no;
   
   sigc::signal<void, Glib::ustring&, Glib::ustring&, Glib::ustring&, Glib::ustring&> event_signal;

public:
   bhcustbox(Glib::ustring& title, Glib::ustring& imagefile, Glib::ustring& message);
   sigc::signal<void, Glib::ustring&, Glib::ustring&, Glib::ustring&, Glib::ustring&> signal_event(){ return event_signal; }
   void Set(Glib::ustring&, Glib::ustring&, Glib::ustring&, Glib::ustring&);
   void on_yes_clicked();
   void on_no_clicked();
};

/* @} 
	@} */

}

/* @} */

}

#endif
