/*
bhselbox.h
Copyright (C) 2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/

#ifndef _BHSELBOX_H
#include <gtkmm/dialog.h>
#include <gtkmm/button.h>
#include <gtkmm/image.h>
#include <gtkmm/label.h>

namespace bhpos{

/**
 * @ingroup mflib
 * @{	
 */
   
namespace widget{

/**
 * @defgroup bhselbox Selection Box
 * @{
 *
 * @ingroup bhwidget
 * @{	
 */
#define _BHSELBOX_H

typedef struct tagBhSelItem{
   char label[64];
   union{
      int   ivalue;
      float fvalue;
   }value;
}BhSelItem;
   
typedef struct tagBhSelList{
   int        num_items;
   BhSelItem *items;
}BhSelList;

class bhselbox : public Gtk::Dialog
{
protected:
   class Gtk::Label  *label;
   class Gtk::Image  *icon;
	class Gtk::Button *yes;
	class Gtk::Button *no;
   
   sigc::signal<void, int, int> event_signal;
   
public:
   bhselbox(char *, char *, char *, BhSelList *);
   sigc::signal<void, int, int> signal_event(){ return event_signal; }
   void on_yes_clicked();
   void on_no_clicked();
};

/* @} 
	@} */

}

/* @} */

}

#endif
