/*
   smartbutton.h
   Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
#ifndef SMARTBUTTON_H
#define SMARTBUTTON_H

#include <gtkmm/main.h>
#include <gtkmm/button.h>
#include <gtkmm/box.h>
#include <gtkmm/label.h>
#include <gtkmm/image.h>
#include <gdk/gdkkeysyms.h>
#include <ctransitems.h>

namespace bhpos{

/**
 * \ingroup mflib
 * \@{	
 */
   
namespace widget{

/**
 * \defgroup smartbutton Smart Button
 * \@{
 *
 * \ingroup bhwidget
 * \@{	
 */

enum BhButtonType{
   BHBUTTON_TYPE_TEXT,
   BHBUTTON_TYPE_GRAPHIC,
   BHBUTTON_TYPE_TEXTGRAPHIC,
   BHBUTTON_TYPE_TEXTGRAPHICACCEL
};

enum BhButtonOrientation{
   BHBUTTON_ORIENTATION_TEXTTOP,
   BHBUTTON_ORIENTATION_TEXTBOTTOM,
   BHBUTTON_ORIENTATION_TEXTBOTH
};

enum BhButtonState{
   BHBUTTON_STATE_DISABLED,
   BHBUTTON_STATE_OFF,
   BHBUTTON_STATE_OVER,
   BHBUTTON_STATE_ON,
   BHBUTTON_STATE_FLASHINGON,
   BHBUTTON_STATE_FLASHINGOFF
};

typedef int (*SBCALLBACK)(GdkEventKey *);
/*! \brief A class to handle buttons.*/
class SmartButton : public Gtk::Button
{
private:
   BhButtonType  type;
   BhButtonState state;
   BhButtonOrientation orientation;
   Gtk::VBox    *vbox;
   Gtk::Image   *image;
   Gtk::Label   *label;
   Gtk::Label   *label2;

   int           qtytype;
   int           producttype;

protected:
   bhpos::CSaleItem sitem;
   sigc::signal<void, bhpos::CSaleItem&> keypress_signal;

public:
   SmartButton();
   //SmartButton(Glib::ustring basedir);
   ~SmartButton();
   //void Set(Gtk::Label *, Gtk::Image *, bhpos::CSaleItem&);
   void SetType(BhButtonType);
   void SetState(BhButtonState);
   void SetOrientation(BhButtonOrientation);
   BhButtonState GetState();
   BhButtonType GetType();
   BhButtonOrientation GetOrientation();
   sigc::signal<void, bhpos::CSaleItem&> signal_keypress(){ return keypress_signal; }
};

/* @} 
	@} */

}

/* @} */

}

#endif   // SMARTBUTTON_H
