/* bhstatus.h
 *
 * Copyright (C) 2001-2005 Al Kingsley
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef BHSTATUS_H
#define BHSTATUS_H

#include <gtkmm/box.h>
#include <gtkmm/entry.h>

namespace bhpos{

/**
 * \ingroup mflib
 * \@{	
 */
   
namespace widget{

/**
 * \defgroup bhstatus Status
 * \@{
 *
 * \ingroup bhwidget
 * \@{	
 */

enum BhStatusItem{
   BHSTATUS_STATUS,
   BHSTATUS_USER,
   BHSTATUS_MODE,
   BHSTATUS_SYSTEM
};   

/*! \brief A class to handle the status bar.*/
class BhStatus : public Gtk::HBox
{
public:
   BhStatus();
   explicit BhStatus(BaseObjectType* cobject);
//   explicit BhStatus(bhentry_type t = TYPE_TEXT);
   virtual ~BhStatus();
   void SetText(BhStatusItem b, Glib::ustring buff);
   void SetColour(BhStatusItem, Gtk::StateType, Gdk::Color);
   void SetBackground(BhStatusItem, Gtk::StateType, Gdk::Color);

protected:
   class Gtk::Entry *status;
   class Gtk::Entry *user;
   class Gtk::Entry *mode;
   class Gtk::Entry *system;
};


/* @} 
	@} */

}

/* @} */

}

#endif // BHSTATUS_H
